
# -------------------------------------------------------------------
# authentication routines

sub authenticate_parse_cookie() 
{
	my $ck;
	my $key;
	my $value;
	my $kv;
	my ($unam,$upwd);
	my ($snam,$scrypt);

	$ck=0;

	@cookies=split (/;\s/,$ENV{'HTTP_COOKIE'}); # split cookies into table
    foreach $kv (@cookies)
	{
		($key,$value)=split (/=/,$kv);
		if ($key eq "user") {$unam=$value;}
		if ($key eq "pwd") {$upwd=$value;}
	}

	($snam,$scrypt,$foo)=getpwnam($unam);
	$salt=substr($scrypt,0,2);
	$ucrypt=crypt($upwd,$salt);
	
	if (($unam ne "") && ($snam eq $unam) && ($ucrypt eq $scrypt)) { $ck=1; }
    return ($ck);
}


sub authenticate_user() # print login screen
{
	print &PrintHeader;
	tools_head();

	print '<br><br><br><br><br><br>

<form action="webmh.cgi" method="POST">
<table border="1" cellpadding="2" align="center" bgcolor="'.$c_backdrop.'">
<tr><th colspan=3>'.$c_fontBar.'WebMH User Login</font></th></tr>
<tr><td bgcolor="'.$c_backdrop_l.'">'.$c_font.'Username:</font></td>
    <td align="right" colspan="2" bgcolor="'.$c_backdrop_l.'">
    <input type="text" name="UNAME" size=8></td>
</tr>
<tr><td bgcolor="'.$c_backdrop_l.'">'.$c_font.'Password:</font></td>
    <td bgcolor="'.$c_backdrop_l.'" align="right" colspan="2">
    <input type="password" name="UPWD" size=8></td>
</tr>
<tr><td align=right colspan=3>'.$c_font.'
	<input type="hidden" name="UACT" value="login">
    <input type="submit" value="login">
    <input type="reset" value="clear"></font></td>
    </tr></table></form>
</body>
</html>
';

        exit 0;
}

sub authenticate_setcookie()
{
	my ($unam,$upwd)=@_;
	print "Content-Type: text/html\n";
	($ci)=authenticate_chk_user($unam,$upwd);
 
        if ($ci==0)
        {
                print "Set-Cookie: user=".$unam.";","\n";
                print "Set-Cookie: pwd=".$upwd.";","\n\n";
       
				display_root_frame_main();
                exit 0;
        } else {
                print "\n";
                tools_head();
                print $c_font.'<br><br><br>
<center>User failed to authenticate.<br>
(press "back" and try again)</center>'."\n";
                tools_tail();
                exit 0;
        }
}

sub authenticate_chk_user() # check if password is right.
{
	my ($unam,$upwd)=@_;
	my ($snam,$scrypt);
	my $ck;

	$ck=0;
	($snam,$scrypt,$foo)=getpwnam($unam);
	$salt=substr($scrypt,0,2);
	$ucrypt=crypt($upwd,$salt);

	if ($ucrypt eq $scrypt) { $ck=0; } else { $ck=1;}	

	$whoami=`/usr/bin/whoami`; # check that the user is who he claims to be
	chomp $whoami;
	if ($unam ne $whoami)	{ $ck=1; }

	return ($ck);
}

sub authenticate_logout() 
{
        print "Content-Type: text/html\n"; 
        print "Set-Cookie: user=;","\n";
        print "Set-Cookie: pwd=;","\n\n";
        tools_head();
		print "<center><br><br>";
		tools_notify("Logout...",'You have loged out.<br><br>Click <a href="webmh.cgi">login</a> to login again.');
		print '</center>';
        tools_tail();
        exit 0;
}

# -------------------------------------------------------------------

1;

